/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Empresa;
import com.tabajara.base.tables.interfaces.IEmpresa;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class EmpresaRecord extends UpdatableRecordImpl<EmpresaRecord> implements VertxPojo, Record4<Integer, String, String, String>, IEmpresa {

    private static final long serialVersionUID = -955849652;

    /**
     * Setter for <code>public.empresa.empid</code>.
     */
    @Override
    public EmpresaRecord setEmpid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.empresa.empid</code>.
     */
    @Override
    public Integer getEmpid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.empresa.empnome</code>.
     */
    @Override
    public EmpresaRecord setEmpnome(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.empresa.empnome</code>.
     */
    @Override
    public String getEmpnome() {
        return (String) get(1);
    }

    /**
     * Setter for <code>public.empresa.empcnpj</code>.
     */
    @Override
    public EmpresaRecord setEmpcnpj(String value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.empresa.empcnpj</code>.
     */
    @Override
    public String getEmpcnpj() {
        return (String) get(2);
    }

    /**
     * Setter for <code>public.empresa.emplocal</code>.
     */
    @Override
    public EmpresaRecord setEmplocal(String value) {
        set(3, value);
        return this;
    }

    /**
     * Getter for <code>public.empresa.emplocal</code>.
     */
    @Override
    public String getEmplocal() {
        return (String) get(3);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record4 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row4<Integer, String, String, String> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row4<Integer, String, String, String> valuesRow() {
        return (Row4) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Empresa.EMPRESA.EMPID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return Empresa.EMPRESA.EMPNOME;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field3() {
        return Empresa.EMPRESA.EMPCNPJ;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field4() {
        return Empresa.EMPRESA.EMPLOCAL;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getEmpid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getEmpnome();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component3() {
        return getEmpcnpj();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component4() {
        return getEmplocal();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getEmpid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getEmpnome();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value3() {
        return getEmpcnpj();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value4() {
        return getEmplocal();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EmpresaRecord value1(Integer value) {
        setEmpid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EmpresaRecord value2(String value) {
        setEmpnome(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EmpresaRecord value3(String value) {
        setEmpcnpj(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EmpresaRecord value4(String value) {
        setEmplocal(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EmpresaRecord values(Integer value1, String value2, String value3, String value4) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(IEmpresa from) {
        setEmpid(from.getEmpid());
        setEmpnome(from.getEmpnome());
        setEmpcnpj(from.getEmpcnpj());
        setEmplocal(from.getEmplocal());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends IEmpresa> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached EmpresaRecord
     */
    public EmpresaRecord() {
        super(Empresa.EMPRESA);
    }

    /**
     * Create a detached, initialised EmpresaRecord
     */
    public EmpresaRecord(Integer empid, String empnome, String empcnpj, String emplocal) {
        super(Empresa.EMPRESA);

        set(0, empid);
        set(1, empnome);
        set(2, empcnpj);
        set(3, emplocal);
    }

    public EmpresaRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
